;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;General installer configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Name "Micro DVD Player Remote Plugin"
BrandingText " "
OutFile mdvdp_remote.exe
;WindowIcon off

SetDatablockOptimize on
SetDateSave on
SetOverwrite on
CRCCheck on

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Install directory configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DirText "This will install the Micro DVD Player Remote Plugin for ATI Remote Wonder on your computer:" "ATI Remote Wonder directory (autodetected):"
InstallDir "$PROGRAMFILES\Ammo Plugin"
InstallDirRegKey HKLM "SOFTWARE\ATI Technologies\Multimedia\Remote Wonder" "PlugInsPath"
AutoCloseWindow true
ShowInstDetails show

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Component page configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Section "Micro DVD Player Remote Plugin (required)"
  SetOutPath $INSTDIR
  File Release\mdvdp.dll

  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "A" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "B" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "C" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "D" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "E" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "F" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "Enabled" 1
  WriteRegStr   HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player" "Filename" "$INSTDIR\mdvdp.dll"

SectionEnd

Section -post
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote" \
                   "Contact" "tfma@hotmail.com"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote" \
                   "DisplayIcon" "$INSTDIR\Plugins\uninstall-mdvdp.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote" \
                   "DisplayName" "Micro DVD Player Remote Plugin (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote" \
                   "DisplayVersion" "1.0"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote" \
                   "Publisher" "Safai Ma"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote" \
                   "UninstallString" "$INSTDIR\uninstall-mdvdp.exe"
  SetOutPath $INSTDIR
  Delete $INSTDIR\uninstall-mdvdp.exe 
  WriteUninstaller $INSTDIR\uninstall-mdvdp.exe

SectionEnd

Function .onInit

  ; - Is Remote Wonder Running? -
  FindWindow $0 "" "ATIX10"
  IsWindow $0 0 End

  ; - Remote Wonder is Running -
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
             "ATI Remote Wonder software is currently running. Close it?$\r$\nSetup will restart the software when it is finished" \
             IDCANCEL \
             TerminateInstall

  ; - Close Remote Wonder -
  SendMessage $0 16 0 0

  ; - Set flag to re-start Remote Wonder
  StrCpy $1 "Restart"  

  Goto End

  ; - User Decided to Abort -
  TerminateInstall:
  MessageBox MB_OK|MB_ICONSTOP "ATI Remote Wonder software cannot be running during setup.$\r$\nAborting setup..."
  Abort

  ; - Carry on Install -  
  End:

FunctionEnd

Function .onVerifyInstDir
  IfFileExists $INSTDIR\..\atix10.exe PathGood
  Abort

  PathGood:
FunctionEnd

Function .onInstSuccess

  ; - Restart Remote Wonder -
  StrCmp $1 "Restart" RestartRW Finish
  
  RestartRW:
  Exec "$INSTDIR\..\atix10.exe"

  ; - Finish -
  Finish:
FunctionEnd

Function .onInstFailed
  MessageBox MB_OK "There were problems installing Micro DVD Player Remote Plugin"
FunctionEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Uninstall configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UninstallText "This will uninstall Micro DVD Player Remote Plugin from your system."

Section Uninstall
  IfFileExists $INSTDIR\mdvdp.dll skip_confirmation
    MessageBox MB_YESNO "It does not appear that Micro DVD Player Remote Plugin is installed in the directory '$INSTDIR'.$\r$\nContinue anyway (not recommended)" IDYES skip_confirmation
    Abort "Uninstall aborted by user"
  skip_confirmation:

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\MDVDP Remote"
  DeleteRegKey HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\Micro DVD Player"

  ; delete plugins
  Delete "$INSTDIR\mdvdp.dll"
  Delete "$INSTDIR\uninstall-mdvdp.exe"

  ; - Restart Remote Wonder -
  StrCmp $1 "Restart" RestartRW Finish
  
  RestartRW:
  Exec "$INSTDIR\..\atix10.exe"

  ; - Finish -
  Finish:

SectionEnd

Function un.onInit

  ; - Is Remote Wonder Running? -
  FindWindow $0 "" "ATIX10"
  IsWindow $0 0 End

  ; - Remote Wonder is Running -
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
             "ATI Remote Wonder software is currently running. Close it?" \
             IDCANCEL \
             TerminateInstall

  ; - Close Remote Wonder -
  SendMessage $0 16 0 0

  ; - Set flag to re-start Remote Wonder
  StrCpy $1 "Restart"  

  Goto End

  ; - User Decided to Abort -
  TerminateInstall:
  MessageBox MB_OK|MB_ICONSTOP "ATI Remote Wonder software cannot be running during uninstall.$\r$\nAborting uninstall..."
  Abort

  ; - Carry on Uninstall -  
  End:
FunctionEnd
